import { EffectType, ItemStack, ItemType, MinecraftEffectTypes, MinecraftItemTypes, world } from "@minecraft/server"
import * as ui from "@minecraft/server-ui"

world.events.tick.subscribe(async evd => {
    for (let p of world.getPlayers()) {
        if (p.getComponent('inventory').container.getItem(p.selectedSlot)?.typeId == 'minecraft:compass') {
            p.addTag('holding')
            p.addEffect(MinecraftEffectTypes.weakness, 99999, 255, false)
        }
        else {
            try {
                p.removeTag('holding')
                await p.runCommandAsync('/effect @s weakness 0 0')
            }
            catch (e) { }
        }
    }
})


world.events.entityHit.subscribe(evd => {
    let user = evd.entity
    let target = evd.hitEntity
    if (target?.typeId != 'minecraft:player' || user?.typeId != 'minecraft:player') return
    if (!user.hasTag('holding')) return
    new ui.ActionFormData()
        .title("GUI")
        .body(target.nameTag)
        .button('Inventory')
        .show(user).then(evd => {
            switch (evd.selection) {
                case 0:
                    var items = []
                    const invScreen = new ui.ActionFormData()
                    invScreen.title("GUI")
                    invScreen.body(`${target.nameTag} Inventory`)
                    for (let n = 0; n < 36; n++) {
                        const invItem = target.getComponent('inventory').container.getItem(n)
                        if (invItem) items.push([invItem, n])
                        if (invItem) invScreen.button(`${invItem.nameTag ? invItem.nameTag : ''} (${invItem.typeId}) x${invItem.amount}`)
                    }
                    invScreen.show(user).then(evd => {
                        let index = evd.selection
                        const itemScreen = new ui.ActionFormData()
                        let item = items[index][0]
                        let slot = items[index][1]
                        itemScreen.title("GUI")
                        itemScreen.body(`§7Item Id: §f${item.typeId}\n§7Custom Name: §f${item?.nameTag}\n§7Amount: §f${item.amount}\nSLOT: ${slot}`)
                        itemScreen.button('Clear')
                        itemScreen.show(user).then(evd => {
                                switch (evd.selection) {
                                    case 0:
                                        const air = new ItemStack(MinecraftItemTypes.stick, 0, 0)
                                        target.getComponent('inventory').container.setItem(slot, air)
                                        user.tell(`removed ${item.typeId} from ${target.nameTag}`)
                                        break
                                }
                            })
                    })
                    break
            }
        })
})