import { world, system } from "@minecraft/server";
import * as ui from "@minecraft/server-ui"
import { op, deop } from "./op"
import { Home } from "./src/classes";
import "./worldedit"

var startedUp = false
const overworld = world.getDimension("overworld")
var x, y, z
var homeToggle
world.events.worldInitialize.subscribe(async evd => {

    await overworld.runCommandAsync(`async function setup`)
    for (let e of world.getDimension('overworld').getEntities()) {
        if (e.typeId == 'wwe:loader') {

            homeToggle = world.scoreboard.getObjective('homeToggle').getScore(e.scoreboard)
        }
    }



})

system.run(async function go() {
    system.run(go)
    if (!startedUp) {
        for (let player of world.getPlayers()) {
            if (player.hasTag('owner')) {
                startedUp = true
            }
            else {
                player.addTag('owner')
                player.addTag('admin')
            }
        }
    }
    await overworld.runCommandAsync(`execute @a[tag=!join] ~ ~ ~ async function join`)
})

world.events.beforeChat.subscribe(async evd => {
    let msg = evd.message
    let sender = evd.sender
    let cmd = '!'
    var args = msg.replace('!', '').split(' ')
    evd.cancel = true
    if (msg.startsWith(`${cmd}`)) {
        switch (args[0]) {
            case ('sethome'): {
                if (homeToggle == 0) {
                    await overworld.runCommandAsync(`tellraw "${sender.name}" {"rawtext":[{"text":"§chome commands are disabled"}]}`)
                }
                else {
                    var home = new Home(sender, sender.location.x, sender.location.y, sender.location.z)
                    await sender.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§aHome set at ${home.formatted()}"}]}`)
                    await sender.runCommandAsync(`scoreboard players set @s x ${home.x}`)
                    await sender.runCommandAsync(`scoreboard players set @s y ${home.y}`)
                    await sender.runCommandAsync(`scoreboard players set @s z ${home.z}`)
                }
                break
            }
            case ('admins'): {
                await sender.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§l§badmins online:§r\n"},{"selector":"@a[tag=admin]"}]}`)
                break
            }
            case ('home'): {
                if (homeToggle == 0) await overworld.runCommandAsync(`tellraw "${sender.name}" {"rawtext":[{"text":"§chome commands are disabled"}]}`)
                else {
                    x = await sender.runCommandAsync('scoreboard players test @s x * *').statusMessage.split(' ')
                    y = await sender.runCommandAsync('scoreboard players test @s y * *').statusMessage.split(' ')
                    z = await sender.runCommandAsync('scoreboard players test @s z * *').statusMessage.split(' ')
                    await sender.runCommandAsync(`tp @s ${x[1]} ${y[1]} ${z[1]}`)
                    await sender.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§aWelcome home"}]}`)
                }
                break
            }
            default: {
                if (sender.hasTag('admin') || sender.name == 'Wilco2933' || sender.name == 'WilcoDev') {
                    switch (args[0]) {
                        case ('admins'): {
                            break
                        }
                        case ('toggle'): {
                            break
                        }
                        case ('wand'): {
                            break
                        }
                        case ('brush'): {
                            break
                        }
                        case ('pos1'):
                            break

                        case ('pos2'): {
                            break
                        }
                        case ('set'): {
                            break
                        }
                        case ('pyramid'): {
                            break
                        }
                        case ('copy'): {
                            break;
                        }
                        case ('cut'): {
                            break;
                        }
                        case ('paste'): {
                            break
                        }
                        case ('stack'): {
                            break
                        }
                        case ('help'): {
                            await sender.runCommandAsync(`tellraw @s {"rawtext":[{"text":"\n§a§lWilco Essentials Commands\n\n§r§7!admins §adisplays all online members with WorldEdit permissions\n\n§r§7!i - §agives you specified item\n§7!i <item> <amount> <item data>\n\n§7!! - §atoggles super pick\n\n§7!vanish - §atoggles your visibility\n\n§7!feed - §agives you full hunger\n\n§7!heal - §agives you full health\n\n§7!broadcast - §asend a chat message as the server\n\n§7!invsee - §acheck the items in a player's inventory\n§7!invsee <player>\n\n§7!togglehome - §atoggles home commands for all players\n\n§7!op §agrants Essential commands to specified player\n§7!op <player>\n\n§7!deop §arevokes Essential commands from specified player\n§7!deop <player>\n\n§l§aNon Admin Commands\n\n§r§7!sethome - §asets your current location as home\n\n§7!home - §ateleports you home"}]}`)
                            break
                        }
                        case ('i'): {
                            give(args[1], args[2], args[3], sender)
                            break
                        }
                        case ('op'): {
                            op(sender, args[1], args[2], args[3], args[4])
                            break
                        }
                        case ('deop'): {
                            deop(sender, args[1], args[2], args[3], args[4])
                            break
                        }
                        case ('!'): {
                            await sender.runCommandAsync(`execute @s ~ ~ ~ async function pick`)
                            break
                        }
                        case ('vanish'): {
                            await sender.runCommandAsync(`execute @s ~ ~ ~ async function vanish`)
                            break
                        }
                        case ('feed'): {
                            await sender.runCommandAsync(`effect @s saturation 5 255 true`)
                            await sender.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§bYou have been fed"}]}`)
                            break
                        }
                        case ('heal'): {
                            await sender.runCommandAsync(`effect @s instant_health 1 255 true`)
                            await sender.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§bYou have been healed"}]}`)
                            break
                        }
                        case ('invsee'): {
                            inventory(sender, args[1], args[2], args[3], args[4])
                            break
                        }
                        case ('togglehome'): {
                            await overworld.runCommandAsync('scoreboard players add homeToggle temp 1')
                            for (let e of world.getDimension('overworld').getEntities()) {
                                if (e.typeId == 'wwe:loader') {
                                    homeToggle = world.scoreboard.getObjective('homeToggle').getScore(e.scoreboard)
                                }
                            }
                            if (homeToggle == 1) await overworld.runCommandAsync(`tellraw "${sender.name}" {"rawtext":[{"text":"§bhome commands enabled"}]}`)
                            else if (homeToggle == 2) {
                                await overworld.runCommandAsync('scoreboard players set @e[type=wwe:loader] homeToggle 0')
                                await overworld.runCommandAsync(`tellraw "${sender.name}" {"rawtext":[{"text":"§bhome commands disabled"}]}`)
                                for (let e of world.getDimension('overworld').getEntities()) {
                                    if (e.typeId == 'wwe:loader') {
                                        homeToggle = world.scoreboard.getObjective('homeToggle').getScore(e.scoreboard)
                                    }
                                }
                            }
                            break
                        }
                        case ('broadcast'): {
                            let broadcast = msg.slice(11)
                            await sender.runCommandAsync(`tellraw @a {"rawtext":[{"text":"<§dSERVER§r> ${broadcast}"}]}`)
                            break
                        }
                        default: {
                            await sender.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§cUnkown command: ${args[0]}"}]}`)
                            break
                        }
                    }
                }
                else {
                    if (args[0] === 'help')
                        await sender.runCommandAsync(`tellraw @s {"rawtext":[{"text":"\n§a§lWilco Essentials Commands\n\n§r§7!sethome - §asets your current location as home\n\n§7!home - §ateleports you home"}]}`)
                    else
                        await sender.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§cYou do not have permission to use this command or the command doesn't exist"}]}`)
                }
            }

        }
    }
    else {
        if (sender.name == 'Wilco2933' || sender.name == 'WilcoDev') await sender.runCommandAsync(`tellraw @a {"rawtext":[{"text":"§8[§aCreator§8] §r<${sender.name}> ${msg}"}]}`)
        else if (sender.hasTag('owner')) await sender.runCommandAsync(`tellraw @a {"rawtext":[{"text":"§8[§4Owner§8] §r<${sender.name}> ${msg}"}]}`)
        else if (sender.hasTag('admin')) await sender.runCommandAsync(`tellraw @a {"rawtext":[{"text":"§8[§bAdmin§8] §r<${sender.name}> ${msg}"}]}`)
        else if (sender.hasTag('mod')) await sender.runCommandAsync(`tellraw @a {"rawtext":[{"text":"§8[§dMod§8] §r<${sender.name}> ${msg}"}]}`)
        else if (sender.hasTag('vip')) await sender.runCommandAsync(`tellraw @a {"rawtext":[{"text":"§8[§gVIP§8] §r<${sender.name}> ${msg}"}]}`)
        else await sender.runCommandAsync(`tellraw @a {"rawtext":[{"text":"§8[§7Member§8] §r<${sender.name}> ${msg}"}]}`)
    }
})

world.events.itemUse.subscribe(evd => {
    if (evd.item.typeId != 'minecraft:compass') return
    new ui.ActionFormData()
        .title("GUI")
        .button()
})

async function give(item = 'undefined', amount = '1', id = '0', sender) {
    if (item == 'undefined') {
        await sender.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§cplease enter an item name"}]}`)
    }
    else {
        try {
            await sender.runCommandAsync(`give @s ${item} ${amount} ${id}`)
        }
        catch {
            await sender.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§cUnknown item: ${item}"}]}`)
        }
    }
}


async function inventory(sender, args1 = '', args2 = '', args3 = '', args4 = '') {
    let target = 'undefined'
    var items = []
    var cmdName = []
    if (args1 == '') {
        target = 'undefined'
    }
    else {
        if (args2 == '') {
            cmdName.push(args1)
        }
        else if (args3 == '') {
            cmdName.push(args1, args2)
        }
        else if (args3 == '') {
            cmdName.push(args1, args2, args3)
        }
        else {
            cmdName.push(args1, args2, args3, args4)
        }
        target = cmdName.join(' ')
        target = target.replace(',', ' ')
    }
    for (let player of world.getPlayers()) {
        if (player.name == `${target}`) {
            let playerInv = player.getComponent('inventory').container
            if (target === 'undefined') {
                await sender.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§cPlease enter a player name"}]}`)
                return false
            }
            else if (player.name != target) {
                return true
            }
            else if (player.name == target) {
                await sender.runCommandAsync(`tellraw @s{"rawtext":[{"text":"§lThe inventory of §b${target} §fcontains:\n"}]}`)
                for (let n = 0; n < playerInv.size; n++) {
                    let item = playerInv.getItem(n)
                    if (item) {
                        await sender.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§7 ${n}  >  §f${item.typeId.replace('minecraft:', '')} : ${item.data} §7(x${item.amount})\n"}]}`)
                    }
                }
                return false
            }
        }
    }
}


