import { world, system } from "@minecraft/server";
import { Position } from "./src/classes";
var startedUp = false
var brushpos = new Position(0, 0, 0)
var pyrpos, paste, size
const overworld = world.getDimension("overworld"); world.getDimension("nether"); world.getDimension("the end")
var structure = "sphere"
var allPlayers = world.getPlayers()
var loader
var wwe = true

world.events.worldInitialize.subscribe(async evd => {
    await overworld.runCommandAsync(`async function setup`)
})

var pos1 = new Position(0, 0, 0)
var pos2 = new Position(0, 0, 0)

system.run(async function go() {
    system.run(go)
    if (!startedUp) {
        for (let player of world.getPlayers()) {
            for (let e of overworld.getEntities()) {
                if (e.typeId == 'wwe:loader') {
                    loader = e
                }
            }
            if (player.hasTag('owner')) {
                startedUp = true
            }
            else {
                player.addTag('owner')
                player.addTag('admin')
            }
        }
    }
    if (loader.hasTag('wwe')) wwe = true;
    else if (!loader.hasTag('wwe')) wwe = false;
    if (wwe) {
        await overworld.runCommandAsync(`titleraw @a actionbar {"rawtext":[{"text":"§b${pos1.formatted()}  §l->  §r§b${pos2.formatted()}"}]}`)
        await overworld.runCommandAsync(`execute as @a[scores={brush=1}] at @s positioned ^ ^ ^30 run structure load ${structure} ~${brushpos.x} ~${brushpos.y} ~${brushpos.z}`)
        await overworld.runCommandAsync(`execute as @a[hasitem={item=wwe:brush,location=slot.weapon.mainhand}] at @s positioned ^ ^ ^30 run particle ~ ~ ~`)
        await overworld.runCommandAsync(`scoreboard players set @a[scores={brush=1}] brush 0`)
        await overworld.runCommandAsync(`execute @a[tag=!join] ~ ~ ~ async function join`)
    }
})


world.events.entityCreate.subscribe(async evd => {
    if (wwe) {
        let id = evd.entity.typeId
        let location = evd.entity.location
        if (id === 'wwe:set1') {

            pos1 = new Position(location.x, location.y - 1, location.z)
            await overworld.runCommandAsync(`event entity @e[type=wwe:set1] despawn`)
            await overworld.runCommandAsync(`tellraw @a {"rawtext":[{"text":"§dFirst position set: ${pos1.formatted()}"}]}`)
        }
        else if (id === 'wwe:set2') {
            pos2 = new Position(location.x, location.y - 1, location.z)
            await overworld.runCommandAsync(`event entity @e[type=wwe:set2] despawn`)
            await overworld.runCommandAsync(`tellraw @a {"rawtext":[{"text":"§dSecond position set: ${pos2.formatted()}"}]}`)
        }
    }
})


world.events.beforeChat.subscribe(async evd => {
    let msg = evd.message
    let sender = evd.sender
    let cmd = '!'
    const prefix = '!'
    var args = msg.slice(prefix.length).split(' ')
    if (!wwe && msg.startsWith(`${cmd}`) && sender.hasTag('admin')) {
        switch (args[0]) {
            case ('toggle'): {
                loader.addTag('wwe')
                sender.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§bWorld Edit enabled"}]}`)
                break
            }
            default: {
                sender.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§cWorld Edit is disabled. enable it with !toggle"}]}`)
                break
            }
        }
    }
    else if (sender.hasTag('admin') && msg.startsWith(`${cmd}`) && wwe) {
        evd.cancel = true
        switch (args[0]) {
            case ('toggle'): {
                loader.removeTag('wwe')
                sender.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§bWorld Edit disabled"}]}`)
                break
            }
            case ('help'): {
                sender.runCommandAsync(`tellraw @s {"rawtext":[{"text":"\n§a§lWilco WorldEdit Commands\n\n§r§7!wand §agives you an Edit Wand\n\n§7!brush §aset a structure as a brush\n§7!brush <save/load> <structure name> <include air? true / false>\n\n§7!pos1 §asets first edit coordinate\n\n§7!pos2 §asets second edit coordinate\n\n§7!set §afills between set coordinates\n§7!set <block> <block data> <keep/destroy/hollow/outline>\n§7!set <block> <block data> <replace> <block> <block data>\n\n§7!copy §acopies between set coordinates\n§7!copy <include entities? true / false>\n\n§7!cut §acuts between set coordinates\n§7!cut <include entities? true / false>\n\n§7!paste §apastes copied / cut structure where you are standing\n§7!paste <0, 90, 180, 270 degrees>\n\n§7!pyramid §abuilds a pyramid using specified parameters\n§7!pyramid <block> <block data> <size> <is hollow? true / false>\n\n§7!admin §agrants WorldEdit permissions to specified player\n§7!op <player>\n\n§7!deop §arevokes WorldEdit permissions from specified player\n§7!deop <player>"}]}`)
                break
            }
            case ('wand'): {
                sender.runCommandAsync(`give @s wwe:wand`)
                break
            }
            case ('brush'): {
                brush(args[1], args[2], args[3], sender)
                break
            }
            case ('pos1'):
                pos1 = new Position(sender.location.x, sender.location.y, sender.location.z)
                sender.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§dFirst position set: ${pos1.formatted()}"}]}`)
                break

            case ('pos2'): {
                pos2 = new Position(sender.location.x, sender.location.y, sender.location.z)
                sender.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§dSecond position set: ${pos2.formatted()}"}]}`)
                break
            }
            case ('set'): {
                set(args[1], args[2], args[3], args[4], args[5], sender)
                break
            }
            case ('pyramid'): {
                pyramid(args[1], args[2], args[3], args[4], sender)
                break
            }
            case ('copy'): {
                copy(args[1], sender)
                break;
            }
            case ('cut'): {
                cut(args[1], sender)
                break;
            }
            case ('paste'): {
                dopaste(args[1], sender)
                break
            }
            case ('stack'): {
                dostack(args[1], args[2], sender)
                break
            }
        }
    }
    else if (sender.hasTag('admin') == false && msg.startsWith(`${cmd}`) && wwe) {
        sender.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§cYou do not have permission to use this command"}]}`)
        evd.cancel = true
    }

})

async function brush(mode = 'load', name = 'null', air = 'true', player) {
    switch (mode) {
        case ('save'): {
            if (name == 'null') {
                name = 'default'
            }
            if (air == 'false') {
                await player.runCommandAsync(`fill ${pos1.place()} ${pos2.place()} structure_void 0 replace air 0`)
            }
            await player.runCommandAsync(`structure save ${name} ${pos1.place()} ${pos2.place()} false disk`)
            await player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§dBrush save successful"}]}`)
            break
        }
        case ('load'): {
            if (name == 'null') {
                name = 'sphere'
            }
            if (name == 'sphere') {
                brushpos = new Position(-5, -5, -5)
            }
            structure = name
            await player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§dBrush load successful"}]}`)
            break
        }
        default: {
            await player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§cSyntax error: brush mode invalid"}]}`)
            break
        }
    }
}

async function set(block = 'stone', blockid1 = '0', mode = ' ', block2 = 'stone', blockid2 = '0', player) {
    if ((mode === 'hollow' || mode === 'destroy' || mode === 'keep' || mode === 'outline' || mode == ' ')) {
        await player.runCommandAsync(`fill ${pos1.place()} ${pos2.place()} ${block} ${blockid1} ${mode}`)
        await player.runCommandAsync(`tellraw "${player.name}" {"rawtext":[{"text":"§dSet blocks successfully"}]}`)
    }
    else if (mode === 'replace') {
        await player.runCommandAsync(`fill ${pos1.place()} ${pos2.place()} ${block} ${blockid1} ${mode} ${block2} ${blockid2}`)
        await player.runCommandAsync(`tellraw "${player.name}" {"rawtext":[{"text":"§dSet blocks successfully"}]}`)
    }
}
async function copy(include = 'false', player) {
    await player.runCommandAsync(`structure save copy ${pos1.place()} ${pos2.place()} ${include} disk`)
    await player.runCommandAsync(`tellraw "${player.name}" {"rawtext":[{"text":"§dCopy successful"}]}`)
}

async function cut(include = 'false', player) {
    await player.runCommandAsync(`structure save copy ${pos1.place()} ${pos2.place()} ${include} disk`)
    await player.runCommandAsync(`fill ${pos1.place()} ${pos2.place()} air 0`)
    await player.runCommandAsync(`tellraw "${player.name}" {"rawtext":[{"text":"§dCut successful"}]}`)
}

async function dopaste(degrees = '0', player) {
    if (degrees == '0' || degrees == '90' || degrees == '180' || degrees == '270') {
        paste = new Position(player.location.x, player.location.y, player.location.z)
        await player.runCommandAsync(`structure load copy ${paste.place()} ${degrees}_degrees`)
        await player.runCommandAsync(`tellraw "${player.name}" {"rawtext":[{"text":"§dPaste successful"}]}`)
    }
    else {
        await player.runCommandAsync(`tellraw "${player.name}" {"rawtext":[{"text":"§cSyntax error: ${degrees}. Degrees must be 0, 90, 180 or 270"}]}`)
    }
}

async function pyramid(block = 'stone', id = '0', num = '6', fill = 'false', player) {
    switch (fill) {
        case ('true'): {
            pyrpos = new Position(player.location.x, player.location.y, player.location.z)
            size = num / 1
            for (let n = 0; n <= num; n++) {
                await player.runCommandAsync(`fill ${pyrpos.x - size} ${pyrpos.y + n} ${pyrpos.z - size} ${pyrpos.x + size} ${pyrpos.y + n} ${pyrpos.z + size} ${block} ${id}`)
                size--
            }
            size = (num - 1) / 1
            for (let n = 1; n < num; n++) {
                size--
                await player.runCommandAsync(`fill ${pyrpos.x - size} ${pyrpos.y + n} ${pyrpos.z - size} ${pyrpos.x + size} ${pyrpos.y + n} ${pyrpos.z + size} air 0`)
            }
            await player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§dPyramid built successfully"}]}`)
            break
        }
        case ('false'): {
            pyrpos = new Position(player.location.x, player.location.y, player.location.z)
            size = num / 1
            for (let n = 0; n <= num; n++) {
                await player.runCommandAsync(`fill ${pyrpos.x - size} ${pyrpos.y + n} ${pyrpos.z - size} ${pyrpos.x + size} ${pyrpos.y + n} ${pyrpos.z + size} ${block} ${id}`)
                size--
            }
            await player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§dPyramid built successfully"}]}`)
            break
        }
        default: {
            await player.runCommandAsync(`tellraw @s{"rawtext":[{"text":"§cSyntax error: ${args[4]} doesn't exist"}]}`)
            break
        }
    }
}

async function dostack(direction = 'north', amount = '1', player) {
    let ans = 0
    let amountNum = parseInt(amount)
    await player.runCommandAsync(`structure save stack ${pos1.place()} ${pos2.place()} false disk`)
    for (let n = 0; n < amountNum; n++) {
        switch (direction) {
            case ('north'): {
                ans = pos1.z - pos2.z + ans
                await player.runCommandAsync(`structure load stack ${pos1.x} ${pos1.y} ${Math.abs(ans) + pos1.z} 0_degrees`)
                break
            }
            case ('south'): {
                ans = pos1.z - pos2.z + ans
                await player.runCommandAsync(`structure load stack ${pos1.x} ${pos1.y} ${Math.abs(ans) + pos1.z} 0_degrees`)
                break
            }
            case ('west'): {
                ans = pos1.x - pos2.x + ans
                await player.runCommandAsync(`structure load stack ${-Math.abs(ans) + pos1.x} ${pos1.y} ${pos1.z} 0_degrees`)
                break
            }
            case ('east'): {
                ans = pos1.z - pos2.z + ans
                await player.runCommandAsync(`structure load stack ${Math.abs(ans) + pos1.x} ${pos1.y} ${pos1.z} 0_degrees`)
                break
            }
            case ('up'): {
                ans = pos1.y - pos2.y + ans
                await player.runCommandAsync(`structure load stack ${pos1.x} ${Math.abs(ans) + pos1.y} ${pos1.z} 0_degrees`)
                // await player.runCommandAsync(`tellraw @s{"rawtext":[{"text":"§c ${ans}\n${output}\n${Math.abs(ans)+pos1.y}"}]}`)
                break
            }
            case ('down'): {
                ans = pos1.y - pos2.y + ans
                await player.runCommandAsync(`structure load stack ${pos1.x} ${Math.abs(ans) + pos1.y} ${pos1.z} 0_degrees`)
                break
            }
        }
    }
}

